VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Edit Distribution Lists Sample"
   ClientHeight    =   5175
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   7290
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5175
   ScaleWidth      =   7290
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAddUser 
      Caption         =   "&Add User"
      Height          =   315
      Left            =   3840
      TabIndex        =   6
      Top             =   3480
      Width           =   1215
   End
   Begin VB.CommandButton cmdCreateList 
      Caption         =   "&Create List"
      Height          =   315
      Left            =   1440
      TabIndex        =   5
      Top             =   3480
      Width           =   1215
   End
   Begin VB.ListBox listMembers 
      Height          =   2985
      Left            =   3840
      TabIndex        =   4
      Top             =   420
      Width           =   3375
   End
   Begin VB.ListBox listDLs 
      Height          =   2985
      Left            =   60
      TabIndex        =   2
      Top             =   420
      Width           =   3375
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   435
      Left            =   6120
      TabIndex        =   1
      Top             =   4680
      Width           =   1095
   End
   Begin VB.CommandButton cmdDeleteList 
      Caption         =   "&Delete List"
      Height          =   315
      Left            =   60
      TabIndex        =   0
      Top             =   3480
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Distribution list aliases:"
      Height          =   195
      Left            =   60
      TabIndex        =   3
      Top             =   180
      Width           =   1935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "Help"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'This project demonstrates how to create and delete public distribution lists as well as add members
'to existing public distribution lists in Unity.  This code sample requires Unity 4.0(3) or later
'since it uses new stored procedures added after the release of 4.0(2).

'As with all the sample code provided as programmatic administration examples, this is not intended
'as a VB tutorial by any stretch.  I've greatly simplified the applications, in most cases pulling all
'the code into the main form so it's easy to find what you're looking for and follow the application
'from start to finish without having to go chasing through too many modules and classes to figure out
'what's happening.  In this example you'll find a few modules necessary for easily accessing the registry
'and checking the Unity version of the local install.

'NOTE: This, as with all the code samples on my site, are written against and tested with Unity 4.0(1)
'and later.  Many will work fine with 3.x versions of Unity, however I will not help you with problems you
'may encounter due to subtle (and not so subtle) differences between the versions.  This particular example
'will basically catch fire and drive into the ditch on versions of Unity prior to 4.0(3).

'You may use and modify this and all code I post on CiscoUnityTools.com (AnswerMonkey.net) any way you
'wish without crediting me or Cisco Systems.  Just think nice thoughts about us when you do it.

'IMPORTANT: This source is provided "as is" and includes no warranty or guarantees of any kind.
'Short story - you use it, you're responsible for what happens.  End of story.  Test heavily before
'deploying in any kind of production environment and make sure you have a good backup before getting too
'far into the testing process.  Cisco TAC (Technical Assistance Center) does NOT support the use of code
'to administer Unity by anyone in the field so they will not assist you with problems you may encounter.
'Refer to the help file included with the sample application for information on where you can get help.

'And now, on with our show...
'=============================================


'At form load time we need to populate the subscriber list box.  For the purposes of this very simple example
'I'm only going to be filing in the alias in a list box - for a production application you'd want to use a nice
'grid control of your choice to show display names, extension if present etc...
Private Sub Form_Load()
    
    'Check the version here - This example only works with Unity 4.0(3) and later since the stored procedures needed
    'were not in or fully working until then.  The version checking module (UnityVersion.bas) contains all the logic
    'for reading the local Unity version out of the registry and also provides a simple function used here for
    'checking minimum version compliance.
    
    'first, load the version
    UnityVersion.UnityVer = UnityVersion.getVersion
    
    'The stored procs were actually present in 4.0(2.112) so I check for that here - 4.0(2.121) was the version that
    'was released as 4.0(3) just for the record.
    If UnityVersion.bIsVersionGreaterThanOrEqualTo(4, 0, 2, 112) = False Then
        MsgBox "This code sample only works on Unity 4.0(3) and later.  Exiting..."
        myFinalExit
    End If
    
    'set the global connection string here - again, we're simplifying this and assuming we're running
    'on the local Unity server - for details on the process for finding and connecting to a remote
    'Unity server, see the programming example for that on CiscoUnityTools.com.
    strConnectionString = "Driver={SQL Server};server=;database=UnityDb"
    
    'populate the list box with the aliases of all the valid public distribution lists on the local system.
    'This is not really an ideal UI for most production applictions but for the purposes of this example it's fine.
    LoadDistributionLists
End Sub

'Loads the aliases of all the distribution lists we can see into the list box on the main form.  Since the
'aliases are unique in the table we can use this string to find the DL in SQL when we need to.
Public Sub LoadDistributionLists()
Dim rs As ADODB.Recordset

    On Error GoTo LoadSubscriberList_Error

    strConnectionString = "Driver={SQL Server};server=;database=UnityDb"
    
    'go fetch the alias for all the subscriber templates on the local box
    Set rs = New ADODB.Recordset
    rs.CursorLocation = adUseClient
    rs.Open "SELECT Alias FROM vw_DistributionList ORDER BY Alias", strConnectionString, adOpenKeyset, adLockReadOnly
    
    'clear the list box
    listDLs.Clear
    
    'dump all the alias strings form the recordset into the list box for selection
    rs.MoveFirst
    Do While rs.EOF = False
        Me.listDLs.AddItem rs("Alias")
        rs.MoveNext
    Loop
    
    'close up shop and bail out.
    rs.Close
    Set rs = Nothing

    Exit Sub
LoadSubscriberList_Error:
    MsgBox "(error):" & Err.Number & " (" & Err.Description & ") in procedure LoadSubscriberList of Form frmMain"
    Debug.Assert False
    Resume Next
End Sub

'When a user clicks on a DL in the drop down list, force the members of the current DL to be displayed.
Private Sub listDLs_Click()
    UpdateMemberInfo
End Sub


'When the user clicks on a distribution list in the ListDLs list box, update the member information that's shown in the
'ListMembers list box.
Private Sub UpdateMemberInfo()
Dim strSQL As String
Dim rsMembers As New ADODB.Recordset

    On Error GoTo UpdateMemberInfo_Error
    
    'If there is no selected distribtuion list exit out.  this can happen at form load time where the list box change event
    'fires even though there may be no distribution lists shown in there yet.
    If Me.listDLs.ListIndex < 0 Then
        Exit Sub
    End If
    
    listMembers.Clear
    
    'go fetch all the subscribers that are top level members of this distribution list.  There are other distribution lists that can
    'be top level members as well but we don't get those here.
    strSQL = "SELECT vw_Subscriber.Alias FROM vw_Subscriber INNER JOIN vw_SystemDListMember ON vw_systemDListMember.DirectoryID=vw_Subscriber.DirectoryID WHERE ParentAlias='" + listDLs.Text + "'"
    
    rsMembers.CursorLocation = adUseClient
    rsMembers.Open strSQL, strConnectionString, adOpenKeyset, adLockReadOnly
    
    If rsMembers.RecordCount = 0 Then
        Exit Sub
    End If
    
    rsMembers.MoveFirst
    
    'iterate through the resulting recordset and add the alias of all top level subscribers in the selected
    'distribution list to the listbox.  Remember that only top level subscribers and DLs are included in the
    'list for system distribution lists.  We include only the top level subscribers here. If you want to manually
    'work your way down through all sub lists or wish to display the alias of member DLs here, you can modify the
    'above SQL query to do that.
    Do While rsMembers.EOF = False
        listMembers.AddItem rsMembers("Alias")
        rsMembers.MoveNext
    Loop

    Exit Sub
UpdateMemberInfo_Error:
    MsgBox "(error):" & Err.Number & " (" & Err.Description & ") in procedure UpdateMemberInfo of Form frmMain"
    Debug.Assert False
    Resume Next
End Sub

'Bail out on exit button press
Private Sub cmdExit_Click()
    myFinalExit
End Sub

'Bail out on exit menu selection
Private Sub mnuExit_Click()
    myFinalExit
End Sub

'Show the help HTML file
Private Sub mnuHelp_Click()
    frmHelp.Show
End Sub

'Select a subscriber to add to a distribution list
Private Sub cmdAddUser_Click()
Dim strSubscriberObjectID As String
Dim strSubscriberAlias As String
Dim strSubscriberDirectoryID As String
Dim strSystemDlistObjectID As String
Dim strDLDirectoryID As String
Dim rsTemp As ADODB.Recordset
Dim strSQL As String
Dim oCommand As ADODB.Command
Dim strSyncTicket As String

    On Error GoTo cmdAddUser_Click_Error

    'make sure a list is selected
    If Me.listDLs.ListIndex < 0 Then
        MsgBox "You must first select a distribution list to add users to"
        Exit Sub
    End If
    
    'get the user to select a subscriber on the local Unity server.
    frmSubscriberSearch.Show vbModal
    
    If frmSubscriberSearch.bCancelHit = True Then
        'the user opted to cancel out of the dialog without selecting a user - exit out
        Exit Sub
    End If
    
    'snag the alias, directoryID and objectID of the subscriber to add.  This stored procedure is a little extra fussy in
    'that it wants both the objectID and DirectoryID of both the subscriber being added and the distribution list they are
    'being added to.  The reasons for this are a bit mysterious but my role is not to ask why...
    strSubscriberObjectID = frmSubscriberSearch.strObjectID
    strSubscriberAlias = frmSubscriberSearch.strAlias
    
    Set rsTemp = New ADODB.Recordset
    rsTemp.CursorLocation = adUseClient
    
    'go fetch the subscriber's directoryID which is required for this SP to work properly.
    strSQL = "Select Alias, DirectoryID from vw_Subscriber WHERE SubscriberObjectID='" + strSubscriberObjectID + "'"
    rsTemp.Open strSQL, strConnectionString, adOpenKeyset, adLockReadOnly
    
    If rsTemp.RecordCount = 0 Then
        MsgBox "Error!  Subscriber could not be found by SubscriberObjectID=" + strSubscriberObjectID
        GoTo CleanUp
    ElseIf rsTemp.RecordCount > 1 Then
        MsgBox "Error!  More than one subscriber found by SubscriberObjectID=" + strSubscriberObjectID
        GoTo CleanUp
    End If
    
    'check to see if the DirectoryID for the selected subscriber is NULL - this usually means there was a
    'problem synching them to the directory when they were first entered - either way it spells bad news
    'for us so we'll have to bail out.
    If IsNull(rsTemp("DirectoryID")) Then
        MsgBox "Error! The selected subscriber has a NULL directory ID - this usually means they did not synch to the directory properly when created."
        GoTo CleanUp
    End If
    
    strSubscriberDirectoryID = rsTemp("DirectoryID")
    
    rsTemp.Close
    
    'Check to see if this subscriber is already a top level member of the distribution list
    strSQL = "SELECT vw_Subscriber.Alias FROM vw_Subscriber INNER JOIN vw_SystemDListMember ON vw_systemDListMember.DirectoryID=vw_Subscriber.DirectoryID WHERE ParentAlias='" + listDLs.Text + "' and vw_Subscriber.Alias='" + strSubscriberAlias + "'"
    rsTemp.Open strSQL, strConnectionString, adOpenKeyset, adLockReadOnly
    
    If rsTemp.RecordCount > 0 Then
        MsgBox "This subscriber is already a member of the selected distribution list"
        GoTo CleanUp
    End If
    
    
    rsTemp.Close
    
    'now go fetch the SystemDListObjectID and DirectoryID of the currently selected distribution list that the user
    'wants to add this subscriber to
    strSQL = "SELECT Alias, SystemDListObjectID, DirectoryID from vw_DistributionList WHERE Alias='" + listDLs.Text + "'"
    
    rsTemp.Open strSQL, strConnectionString, adOpenKeyset, adLockReadOnly
    
    If rsTemp.RecordCount = 0 Then
        MsgBox "Error!  Could not find distribution list by selected alias."
        GoTo CleanUp
    ElseIf rsTemp.RecordCount > 1 Then
        MsgBox "Error!  Found more than one match in the distribution list table for selected alias."
        GoTo CleanUp
    End If
    
    'check to see if the DirectoryID is NULL as above - again this usually indicates there was a problem synching the object
    'to the directory when it was created originally.
    If IsNull(rsTemp("DirectoryID")) Then
        MsgBox "Error! The DirectoryID of the selected distribution list is NULL - this usually means there was a problem synching the list to the directory when it was created."
        GoTo CleanUp
    End If
    
    strDLDirectoryID = rsTemp("DirectoryID")
    strSystemDlistObjectID = rsTemp("SystemDListObjectID")
    
    rsTemp.Close
    
    Set oCommand = New ADODB.Command
    oCommand.ActiveConnection = strConnectionString
    oCommand.CommandType = adCmdStoredProc
    
    oCommand.CommandText = "csp_SystemDListMemberCreate"
    
    oCommand.Parameters.Item("@SystemDListObjectID") = oCommand.CreateParameter("SystemDListObjectID", adGUID, adParamInput, , strSystemDlistObjectID)
    oCommand.Parameters.Item("@SystemDListDirectoryID") = oCommand.CreateParameter("SystemDListDirectoryID", adVarChar, adParamInput, , strDLDirectoryID)
    
    oCommand.Parameters.Item("@SubscriberObjectID") = oCommand.CreateParameter("SubscriberObjectID", adGUID, adParamInput, , strSubscriberObjectID)
    oCommand.Parameters.Item("@SubscriberDirectoryID") = oCommand.CreateParameter("SubscriberDirectoryID", adVarChar, adParamInput, , strSubscriberDirectoryID)
    
    'tell the stored proc to force this change into the directory for us.
    oCommand.Parameters.Item("@DirectorySync") = oCommand.CreateParameter("DirectorySync", adInteger, adParamInput, , 1)
    oCommand.Parameters.Item("@DirectorySyncFlags") = oCommand.CreateParameter("DirectorySyncFlags", adInteger, adParamInput, , 1)
    
    'We need to create a GUID that we can pass into the stored proc such that we can look for it in the DirectorySyncTicket
    'table in SQL which is used to pass back the results of this sync
    strSyncTicket = generateDirectorySyncTicket
    oCommand.Parameters.Item("@DirectorySyncTicket") = oCommand.CreateParameter("DirectorySyncTicket", adGUID, adParamInput, , strSyncTicket)
    
    frmMain.Refresh
    frmMain.MousePointer = vbHourglass
    DoEvents
    
    'let the stored proc fly.
    oCommand.Execute
    
    frmMain.MousePointer = vbDefault
    
    'wait for sync process to complete
    If WaitForSyncToFinish(strSyncTicket) = False Then
        MsgBox "(error)SQL Sync to directory failed when adding subscriber to DL" + vbCrLf + "You can check the SQLSyncSvr logs in the \commserver\logs directory for more details"
    Else
        MsgBox "    Directory sync complete for subscriber add"
    End If
    
    'force the currently selected DL to show it's members - which should now include the subscriber we just added.
    UpdateMemberInfo
    
CleanUp:
    'close out the recordsets and exit
    On Error Resume Next
    rsTemp.Close
    Set rsTemp = Nothing
    Set oCommand = Nothing
    
    Exit Sub
cmdAddUser_Click_Error:
    MsgBox "(error):" & Err.Number & " (" & Err.Description & ") in procedure cmdAddUser_Click of Form frmMain"
    Debug.Assert False
    Resume Next
End Sub


'add a new public distribution list to the system
Private Sub cmdCreateList_Click()
Dim strDLAlias As String
Dim strDLDisplayName As String
Dim strAdministratorObjectID As String
Dim oCommand As ADODB.Command
Dim strSyncTicket As String
Dim rsTemp As ADODB.Recordset

    On Error GoTo cmdCreateList_Click_Error

    'Collect the name of the distribution list to be added
    strDLDisplayName = InputBox("Enter display name for new public distribution list", "Enter distribution list display name")
    
    'if the display name is empty bail out.  We'll limit the display name here to 40 characters since the SA limits the input
    'of the display name for DLs to 40 characters as well - this should be sufficient for our purposes here.
    If Len(strDLDisplayName) = 0 Then
        Exit Sub
    ElseIf Len(strDLDisplayName) > 40 Then
        MsgBox "Easy there Tex.  Keep the display name under 40 characters please."
        Exit Sub
    End If
    
    'Check to see if the display name is unique - technically the display name doesn't have to be unique but the SA only
    'shows the display name as a selection criteria and there'd be no way to distinguish the lists apart - as such we'll
    'enforce it here.
    Set rsTemp = New ADODB.Recordset
    rsTemp.CursorLocation = adUseClient
    rsTemp.Open "SELECT Alias, DisplayName FROM vw_DistributionList WHERE DisplayName='" + strDLDisplayName + "'", strConnectionString, adOpenKeyset, adLockReadOnly
    If rsTemp.RecordCount > 0 Then
        MsgBox "That display name conflicts with one or more public distribution lists already in the database.  Please select a unique display name."
        rsTemp.Close
        GoTo CleanUp
    End If
    
    rsTemp.Close
    
    'Generate an Alias from the display name - the SQL Syncher will tack on the system ID of the local Unity install
    'for this so as long as the alias is unqiue within the set of public DLs we know about in SQL you can be pretty
    'sure the alias is unqiue in the directory - if you want to be extra sure you can tack on the number of seconds
    'since midnight on 1/1/2000 or something but it shouldn't be necessary
    strDLAlias = Replace(strDLDisplayName, " ", "_")
    
    'We _should_ check for illegal characters here but since this is a learning project I get to skate on such things
    'by saying it's "left as an exercize for the reader".  Illegal characters would include "\", "'" and others.  If it's
    'me I force it to be only letters, numbers, spaces and underscore - that's it.  No getting funky with punctuation or
    'weird characters you shouldn't be using in my world.  But that's left to you.
    
    'Finally, force the user to select a subscriber to act as the owner/administrator for this list. At this time this
    'value is not actually used for anything other than display purposes in the SA - however eventually it will be and
    'it's considered a database inconsistency if it's not set properly.
    frmSubscriberSearch.Show vbModal
    
    'yeah, this isn't the greatest user interface in the world but hey... for a production appliction I'd probably put
    'this on a seperate form such that the display name and administrator and possibly an optional extension could be
    'entered and checked seperately - for our purposes here, however, the user is just going to take it in the shorts
    'if they screw up here and they'll have to start again.
    If frmSubscriberSearch.bCancelHit Then
        MsgBox "You must select a subscriber to act as the administrator for the new list... please try again."
        GoTo CleanUp
    End If
    
    If Len(frmSubscriberSearch.strObjectID) = 0 Then
        MsgBox "You must select a subscriber to act as the administrator for the new list... please try again."
        GoTo CleanUp
    Else
        strAdministratorObjectID = frmSubscriberSearch.strObjectID
    End If
    
    'force a redraw of the main form and then put the mouse into "I'm working on it" mode.  For a production application
    'I'd probably float a splash screen to the top indicating the DL was being created or the like - but for our
    'purposes here this is fine.
    frmMain.Refresh
    frmMain.MousePointer = vbHourglass
    DoEvents
    
    Set oCommand = New ADODB.Command
    oCommand.ActiveConnection = strConnectionString
    oCommand.CommandType = adCmdStoredProc
    
    'OK, we have everything we need - the alias and display name of the DL to create and the ObjectId of the subscriber
    'that will act as the administrator - let's create the new DL.
    oCommand.CommandText = "csp_DistributionListCreate"
    
    oCommand.Parameters.Item("@Alias") = oCommand.CreateParameter("Alias", adVarChar, adParamInput, , strDLAlias)
    oCommand.Parameters.Item("@DisplayName") = oCommand.CreateParameter("DisplayName", adVarChar, adParamInput, , strDLDisplayName)
    oCommand.Parameters.Item("@AdministratorObjectID") = oCommand.CreateParameter("AdministratorObjectID", adGUID, adParamInput, , strAdministratorObjectID)
    
    oCommand.Parameters.Item("@Undeletable") = oCommand.CreateParameter("Undeletable", adInteger, adParamInput, , 0)
    
    'tell the SQLSyncher to push this new DL into the directory
    oCommand.Parameters.Item("@DirectorySync") = oCommand.CreateParameter("DirectorySync", adInteger, adParamInput, , 1)
    oCommand.Parameters.Item("@DirectorySyncFlags") = oCommand.CreateParameter("DirectorySyncFlags", adInteger, adParamInput, , 2)
    
    'We need to create a GUID that we can pass into the stored proc such that we can look for it in the DirectorySyncTicket
    'table in SQL which is used to pass back the results of this sync
    strSyncTicket = generateDirectorySyncTicket
    oCommand.Parameters.Item("@DirectorySyncTicket") = oCommand.CreateParameter("DirectorySyncTicket", adGUID, adParamInput, , strSyncTicket)
    
    'Let the stored proc fly.
    oCommand.Execute
    
    frmMain.MousePointer = vbDefault
    
    'wait for sync process to complete
    If WaitForSyncToFinish(strSyncTicket) = False Then
        MsgBox "(error)SQL Sync to directory failed when adding new distributionlist" + vbCrLf + "You can check the SQLSyncSvr logs in the \commserver\logs directory for more details"
    Else
        MsgBox "The directory sync is complete for new distribution list"
    End If

    'populate the list box with the aliases of all the valid public distribution lists on the local system.  That
    'will now include the new DL we just added.
    LoadDistributionLists
            
CleanUp:
    'close out the recordsets and exit
    On Error Resume Next
    rsTemp.Close
    Set rsTemp = Nothing
    Set oCommand = Nothing

    Exit Sub
cmdCreateList_Click_Error:
    MsgBox "(error):" & Err.Number & " (" & Err.Description & ") in procedure cmdCreateList_Click of Form frmMain"
    Debug.Assert False
    Resume Next
End Sub

'Delete the currently selected distribution list
Private Sub cmdDeleteList_Click()
Dim oCommand As ADODB.Command
Dim strSyncTicket As String
Dim rsTemp As ADODB.Recordset

    'verify that the user wishes to delete this distribution list
    If MsgBox("Are you sure you want to delete the selected distribution list?", vbYesNo) = vbNo Then
        Exit Sub
    End If
    
    Set rsTemp = New ADODB.Recordset
    rsTemp.CursorLocation = adUseClient
    
    'we need to pass the SystemDListOBjectId and/or the DirectoryID of the selected distribution list into the stored
    'procedure for deletion - as such we'll need to find this record in SQL.
    rsTemp.Open "SELECT SystemDListObjectID, Alias FROM vw_DistributionList WHERE Alias='" + Me.listDLs.Text + "'", strConnectionString, adOpenKeyset, adLockReadOnly
    
    'really none of the 3 error conditions would happen in a typical system but hey... can't be too careful.
    If rsTemp.RecordCount = 0 Then
        MsgBox "Unable to find distribution list by the selected alias."
        GoTo CleanUp
    ElseIf rsTemp.RecordCount > 1 Then
        MsgBox "More than one match for in the distribution list table for the selected alias."
        GoTo CleanUp
    End If
    
    If IsNull(rsTemp("SystemDListObjectID")) Then
        MsgBox "The SystemDListObjectId property for the selected distribution list is NULL."
        GoTo CleanUp
    End If
    
    'display the "hour glass" mouse pointer to indicate we're working on it.
    frmMain.MousePointer = vbHourglass
    
    Set oCommand = New ADODB.Command
    oCommand.ActiveConnection = strConnectionString
    oCommand.CommandType = adCmdStoredProc
    
    'OK, we have everything we need - the alias and display name of the DL to create and the ObjectId of the subscriber
    'that will act as the administrator - let's create the new DL.
    oCommand.CommandText = "csp_DistributionListDelete"
    
    oCommand.Parameters.Item("@SystemDListObjectID") = oCommand.CreateParameter("SystemDlistObjectID", adGUID, adParamInput, , rsTemp("SystemDListObjectID"))
    
    'tell the SQLSyncher to push this new DL into the directory
    oCommand.Parameters.Item("@DirectorySync") = oCommand.CreateParameter("DirectorySync", adInteger, adParamInput, , 1)
    oCommand.Parameters.Item("@DirectorySyncFlags") = oCommand.CreateParameter("DirectorySyncFlags", adInteger, adParamInput, , 2)
    
    'NOTE - we COULD pass in a ForceRemove flag set to 1 here to make the directory monitor remove the distribution list from
    'the directory as well but for this example I just remove it from Unity which will also clean the Unity properties off the
    'list in the directory. As such you can import it again later.
    
    'We need to create a GUID that we can pass into the stored proc such that we can look for it in the DirectorySyncTicket
    'table in SQL which is used to pass back the results of this sync
    strSyncTicket = generateDirectorySyncTicket
    oCommand.Parameters.Item("@DirectorySyncTicket") = oCommand.CreateParameter("DirectorySyncTicket", adGUID, adParamInput, , strSyncTicket)
    
    'Let the stored proc fly.
    oCommand.Execute
    
    frmMain.MousePointer = vbDefault
    
    'wait for sync process to complete
    If WaitForSyncToFinish(strSyncTicket) = False Then
        MsgBox "(error)SQL Sync to directory failed when deleting the distributionlist" + vbCrLf + "You can check the SQLSyncSvr logs in the \commserver\logs directory for more details"
    Else
        MsgBox "The directory sync is complete for the distribution list removal"
    End If

    'populate the list box with the aliases of all the valid public distribution lists on the local system.  That
    'will now not include the DL we just removed.
    LoadDistributionLists
            
CleanUp:
    'close out the recordsets and exit
    On Error Resume Next
    rsTemp.Close
    Set rsTemp = Nothing
    Set oCommand = Nothing
End Sub

